#!/usr/bin/env python

# Copyright (C) Andrew Mitchell 2006

#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
############################################################################

## client side: enable pam_krb5, winbind
# http://lilly.csoft.net/~vdebaere/handleiding/samba-activedirectory/index_en.html (winbind)
# http://www.windowsnetworking.com/articles_tutorials/Authenticating-Linux-Active-Directory.html (kerberos only)
# http://www.wlug.org.nz/ActiveDirectorySamba (kerberos & winbind)
# http://www.wlug.org.nz/ActiveDirectoryKerberos (kerberos only)



from AuthTool import config, authtools

config.methods['AD'] = 'Active Directory Authentication'

class ADConfig(authtools.IAuthConfig):
    name = "AD"
    packages = ["libpam-heimdal","winbind"]
    requires = ["Kerberos", "Winbind"]
    display = True

    def __init__(self, authconfig):
        self.cfg = authconfig

    def config(self):
        """
        Return a list of configuration options in a standardised format
        {'id':['type','label',default','options'],...}
        """

        cfg = {
            
            }

    def enable(self):
        # setup Kerberos (call enable on that)
        # setup winbind config
        # setup /etc/nsswitch.conf (libnss_winbind for passwd & group)
        pass
